/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.statistik.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.statistik.entity.StatistikKennzeichen;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class StatistikKennzeichenExtendedDAO extends AbstractStatistikKennzeichenDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: LaufNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM StatistikKennzeichen o WHERE o.statistikLauf = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<StatistikKennzeichen> findByLauf( @javax.annotation.Nonnull de.ivu.elect.business.statistik.entity.StatistikLauf lauf) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("StatistikKennzeichen.findByLauf" ,  lauf  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByLauf(): Miss");
        }

        cache.put(key, super.findByLauf( lauf  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByLauf(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<StatistikKennzeichen>) cache.lookup(key));
    }

    return super.findByLauf( lauf  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
